import es
import playerlib
import random
from vecmath import vector

info = es.AddonInfo()
info.name = "Magnetic Players"
info.version = "1.0"
info.basename = "mag_players"

alive = None
props = None
propiter = None
playeriter = None
affectnum = 20
velapplier = 20000.0

offs = {
    'origin': 'CBaseEntity.m_vecOrigin'
    }
origin = offs['origin']
    
def round_start(ev):
    global alive, playeriter, props, propiter
    alive = playerlib.getUseridList('#alive')
    if len(alive):
        playeriter = iter(alive)
        props = es.createentitylist('prop_physics_multiplayer').keys()
        propiter = iter(props)
        es.addons.registerTickListener(_ticks)
    else:
        player = None
        try:
            es.addons.unregisterTickListener(_ticks)
        except ValueError:
            pass
def unload():
    try:
        es.addons.unregisterTickListener(_ticks)
    except ValueError:
        pass

def player_death(ev):
    global playeriter
    uid = int(ev['userid'])
    try:
        alive.remove(uid)
        playeriter = iter(alive)
    except (ValueError, AttributeError):
        pass

def _ticks():
    global propiter, playeriter
    for i in xrange(len(props)/5):
        try:
            player = playeriter.next()
        except StopIteration:
            playeriter = iter(alive)
            player = playeriter.next()
        try:
            prop = propiter.next()
        except StopIteration:
            propiter = iter(props)
            es.fire(player, 'prop_physics_multiplayer', 'Wake')
            return
        try:
            playerloc = vector(es.getplayerprop(player, origin))
            proploc = vector(es.getindexprop(prop, origin))
            intermv = playerloc - proploc
            velvec = intermv * velapplier / (intermv.length()**2)
            es.physics('active', 'setvelocity', prop, str(velvec))
        except:
            props.remove(prop)
            propiter = iter(props)
            return

